package code
{
   import code.*;
   import mochi.*;   
   import flash.display.MovieClip;
   import flash.events.*;
   import flash.display.*;
   import flash.utils.Timer;
   import flash.geom.Point;
   import flash.text.*;
   import flash.media.Sound;
   import flash.media.SoundChannel;
   import flash.media.SoundTransform;
   import flash.display.Loader;
   import flash.display.LoaderInfo;
   import flash.net.*;
    
   dynamic public class Main extends MovieClip
   {
      private var gameName = "mentalDrain";
      public static var mainContainer:MovieClip= new MovieClip();
      public static var ballArray = new Array();
      public static var prevBallArrayLength:int=0;
      public static var ballHitCounter:Number;
      public static var answerCorrectCounter:Number;
      public static var timerArrays = new Array();
      public static var foreGround = new m_interface();
      public static var i:uint;
      public static var j:uint;
      public static var mode:uint; //swap, select, or add vowel, delete all same Ball
      public static var enableRollOverSelect:Boolean;
      
      public static var score:m_score = new m_score();
      public static var life:uint;
      public static var playTime:uint;

      public static var firstAppearTime:uint = 2000;
      public static var tempTimer:Timer;
      public static var frameRate = new Framerate();
      public static var hitSound = new sd_fade();
      public static var BGMusic = new BGM();
      
      public static var beforeBombHitCounter:int=0;
      public static var gameIsOver:Boolean;
      public static var loader:Loader = new Loader();
      public static var m_flashIntro = new m_flashosophyIntro();
      public static var instructions = new m_instructions();

      public static var domainName:String;
      public static var lagCounter:int = 10;
      public static var ballGen0:Timer = new Timer(firstAppearTime, 0);
      public static var drainEnergyTimer:Timer = new Timer(30, 0);      
      public static var checkFPSTimer:Timer = new Timer(1000, 0);         
   
      public static var savedEnergy:Number = 0;
      public static var drainSpeed:Number;
      public static var keyInput = new m_keyListener();
      public static var currentMathAnswer:String="";
      public static var ballSpeedX:Number=0;
      public static var ballSpeedY:Number=0;
      public static var speedAmount:Number=0;
      public static var ballDirectionX:int=0;
      public static var ballDirectionY:int=0;
      public static var levelCounter:int=0;
      public var _mochiads_game_id:String = "de1bf1248375f741";

      public function Main()
      {
         m_flashIntro.m_btnStart.addEventListener(MouseEvent.MOUSE_DOWN, m_flashIntroDownHandler) ;
         addChild(instructions);
         addChild(mainContainer);
         MochiAd.showPreGameAd({clip:root, id:_mochiads_game_id, res:"700x600", background:0xFFFFC9, color:0x00BBFF, outline:0x3C83D5, no_bg:true,ad_finished:adFinished});      
         instructions.addEventListener(MouseEvent.MOUSE_DOWN, instructionsDownHandler) ;
      }
      
      public function adFinished():void {
         this.addChild(m_flashIntro);
      }
      
      public static function initVariables(){
         ballArray= new Array();
         timerArrays=new Array();
         clearTimers();
         mode = 0; //no mode
        
         gameIsOver=false;
         ballHitCounter=0;
         answerCorrectCounter=0;
         firstAppearTime=2000;
         playTime=0;

         foreGround.m_gameOver.visible=false;
         foreGround.m_gameOverMask.visible=false;
         foreGround.m_energy0.width =100;
         foreGround.m_energy1.width =100;
      
         beforeBombHitCounter=0;
         prevBallArrayLength=0;
         speedAmount=.2;
         lagCounter=10;
         score.multiplier=1;
         score.resetScore();
         drainSpeed = .1;
         currentMathAnswer = generateMath();
         mainContainer.removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
         mainContainer.addEventListener(Event.ENTER_FRAME, enterFrameHandler);
         var ranDirX:int = randRange(0,1);
         var ranDirY:int = randRange(0,1);
         
         if(ranDirX ==0) ballDirectionX = 1;
            else ballDirectionX =-1;
         
         if(ranDirY ==0) ballDirectionY = 1;
            else ballDirectionY =-1;
            
         ballSpeedX= speedAmount*ballDirectionX;
         ballSpeedY= speedAmount*ballDirectionY;
         
         foreGround.m_game1.x = 505;
         foreGround.m_game1.y = 212;
         foreGround.m_game2.x = 174;
         foreGround.m_game2.y = 456;
         foreGround.m_game3.x = 505;
         foreGround.m_game3.y = 456;
      }
            
      public function instructionsDownHandler(e:Event){openFlashosophyWebsite();}
      public static function openFlashosophyWebsite():void{navigateToURL(new URLRequest("http://www.flashosophy.com") , '_self'); }

      //starts the game after reading instructions
      public function m_flashIntroDownHandler(e:Event){
         m_flashIntro.play();
         instructions.removeEventListener(MouseEvent.MOUSE_DOWN, instructionsDownHandler) ;
         m_flashIntro.m_btnStart.removeEventListener(MouseEvent.MOUSE_DOWN, m_flashIntroDownHandler) ;
         removeChild(instructions)
         removeChild(m_flashIntro)
         initGame();
      }
           
      public function initGame(){
         mainContainer.addChild(foreGround);
         foreGround.addChild(score);
         foreGround.addChild(frameRate);
         foreGround.x = 10;
         foreGround.y = 10;
         frameRate.visible =false
         startGame();
         checkFPSTimer.addEventListener("timer", checkFPSHandler);
         checkFPSTimer.start();
         addChild(keyInput);
         keyInput.startControls();  
      }
      
      //checks for fps drop
      public function checkFPSHandler(e:Event){
         playTime++;
         score.updateScoreNoPop(1);
         levelCounter++;
         if(levelCounter == 30)
         {
            levelCounter=0;
            drainSpeed+=.1;
            speedAmount+=.2;
         }
         
         if(frameRate.fps <= 8){
            lagCounter--;
            if(lagCounter <= 0){
               score.resetScore();           
               foreGround.m_lagPlay.play();
            }
         }
      }
      
      public static function startGame(){
         initVariables();
         drainEnergyTimer.addEventListener("timer", drainEnergyTimerHandler);
         drainEnergyTimer.start();
         timerArrays.push(drainEnergyTimer);
         mainContainer.stage.quality = StageQuality.HIGH; 
         BGMusic.stopBGMImmediate()
         BGMusic.playBGM(); 
         checkFPSTimer.start();
         foreGround.m_game1.addEventListener("click", game1ClickHandler);
      }
      
      //controls game2 and game3 ball movement 
      private static function enterFrameHandler(e:Event){      
         foreGround.m_game2.x += ballSpeedX;
         foreGround.m_game3.y += ballSpeedY;
         
         if(foreGround.m_game2.hitTestObject(foreGround.m_gameWallLeft) ||
            foreGround.m_game2.hitTestObject(foreGround.m_gameWallRight) ||
            foreGround.m_game3.hitTestObject(foreGround.m_gameWallUp) ||
            foreGround.m_game3.hitTestObject(foreGround.m_gameWallDown) )
         {
            gameOver();
         }         
      }
 
      public static function drainEnergyTimerHandler(e:Event){
         //playGame0
         foreGround.m_energy0.width -= drainSpeed;
         foreGround.m_energy1.width -=drainSpeed;
         
         if(foreGround.m_energy0.width <=1 || foreGround.m_energy1.width <= 1){
            gameOver();
         }
      }   
      
      //playGame1
      public static function game1ClickHandler(e:Event){
         showLifeIncrease(1,10,1)
         foreGround.m_game1.x = randRange(364, 655);
         foreGround.m_game1.y = randRange(133, 306);
         ballHitCounter++;
      }
      
      //game0 checker
      public static function keyEntered(in_Str:String){
         var strLength:int = in_Str.length;
         //adding support for numpad
         if(in_Str == "Numpad 0" || in_Str == "Numpad 1" || in_Str == "Numpad 2" || 
         in_Str == "Numpad 3" || in_Str == "Numpad 4" || in_Str == "Numpad 5" ||
         in_Str == "Numpad 6" || in_Str == "Numpad 7" || in_Str == "Numpad 8"  || in_Str == "Numpad 9" )
         {
            in_Str = in_Str.substring(strLength-1, strLength);
         }
      
         if( in_Str=="0" || in_Str=="1" || in_Str=="2" || in_Str=="3" || in_Str=="4"
          || in_Str=="5" || in_Str=="6" || in_Str=="7" || in_Str=="8" || in_Str=="9"){
 
            if(currentMathAnswer == in_Str){
               showLifeIncrease(0,10,1) //energy0, amount, points
               answerCorrectCounter++;
            }else
            {
               showLifeIncrease(0,-10,-3)
               shakeScreen();               
            }
            currentMathAnswer = generateMath();
         }
         else
         if( in_Str=="Left Arrow" ){
            ballSpeedX = speedAmount * -1;
         }
         else
         if( in_Str=="Right Arrow" ){
            ballSpeedX = speedAmount;
         }
         else
         if( in_Str=="Up Arrow" ){
            ballSpeedY = speedAmount * -1;
         }
         else
         if( in_Str=="Down Arrow" ){
            ballSpeedY = speedAmount;
         }
      }
      
      private static function generateMath():String{
         var operator:int =  randRange(0,1);
         var firstNum:int = randRange(0,9);
         var secondNum:int = randRange(0,9);
         var txtStr:String= "";
         var answerStr:String= "";
         
         if(operator == 0){ //0 means subtraction
            while( (firstNum - secondNum) < 0){//makes sure answer is withim 0 and 9
               secondNum = randRange(0,9);
            }
            txtStr = firstNum+"-"+secondNum;
            answerStr =firstNum-secondNum+"";
         }
         else //addition
         {
            while( (firstNum + secondNum) > 9){//makes sure answer is withim 0 and 9
               secondNum = randRange(0,9);
            }
            txtStr = firstNum+"+"+secondNum;
            answerStr =firstNum+secondNum+"";
         }
         foreGround.m_game0.tf_txt.text = txtStr;
         return answerStr;
      }
      
      public static function showLifeIncrease(in_target:int, in_Life:int, in_score:int){
         score.updateScore(in_score, 1000, 1000, 16);  
         if(in_target==0){
            foreGround.m_energy0.width+=in_Life;
            if(foreGround.m_energy0.width > 320 )
               foreGround.m_energy0.width = 320
         }
         else{
           foreGround.m_energy1.width+=in_Life;
           if(foreGround.m_energy1.width > 320 )
               foreGround.m_energy1.width = 320
         }
      }
          

      public static function clearTimers(){
         for(i=0;i < timerArrays.length; i++){
            timerArrays[i].stop();
            timerArrays[i]=null;  
          }
         timerArrays.length=0;
         timerArrays=new Array();
         checkFPSTimer.stop();
         mainContainer.removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
      }
            
      public static function gameOver(){
         gameIsOver =true;
         shakeScreen();
         foreGround.m_gameOverMask.visible=true;
         drainEnergyTimer.stop();
         
         var submitScore:int=score.gettotalScore();
         foreGround.m_gameOver.visible = false;
         
         score.resetScore();
         clearTimers();
         MochiServices.connect("de1bf1248375f741", mainContainer);
         MochiScores.showLeaderboard({boardID:"6f8547e4d000934c",score:submitScore , hideDoneButton: true, onClose:function(){return;} });

      }
      
      public static function shakeScreen(){
         var bgHitSound = new sd_hit();
         var channel:SoundChannel = bgHitSound.play();
         var shakeTimer = new Timer(100, 4);
         shakeTimer.addEventListener("timer", shakeTimerHandler);
         shakeTimer.start();     
         
         var shakeTimer2 = new Timer(150, 2);
         shakeTimer2.addEventListener("timer", shakeTimerHandler2);
         shakeTimer2.start(); 
         
         var shakeTimer3 = new Timer(300, 2);
         shakeTimer3.addEventListener("timer", shakeTimerHandler3);
         shakeTimer3.start();    

         var fixTimer = new Timer(620, 1);
         fixTimer.addEventListener("timer", fixTimerHandler);
         fixTimer.start();  
      }
         
      public static function shakeTimerHandler(e:Event){
         mainContainer.x = 2;
         mainContainer.y = 2;
      }
 
      public static function shakeTimerHandler2(e:Event){
         mainContainer.x = 1;
         mainContainer.y = -2;       
      }

      public static function shakeTimerHandler3(e:Event){
         mainContainer.x = -3;
         mainContainer.y = 1;         
      }      
      
      public static function fixTimerHandler(e:Event){
         mainContainer.x = 0;
         mainContainer.y = 0;
      }
      
      
      public static function randRange(min:Number, max:Number):Number{
          var randomNum:Number = Math.floor(Math.random() * (max - min + 1)) + min
          return randomNum
      }

   }//end class
}


