package code
{
   import flash.display.MovieClip;
   import flash.display.Sprite;
   import flash.display.DisplayObject;
   import flash.events.Event;
   import flash.events.TimerEvent;
   import flash.utils.Timer;

   import flash.filters.BitmapFilter;
   import flash.filters.BitmapFilterQuality;
   import flash.filters.BitmapFilterType;
   import flash.filters.GradientGlowFilter;
   import flash.text.*;
   
   public class Score extends MovieClip
   {
      private var bgColor:uint      = 0xFFFFFF;
      private var borderColor:uint  = 0xFFFFFF;
      private var borderSize:uint   = 3;
      private var cornerRadius:uint = 9;
      private var numKills:uint;
      private var totalScore:int;

      private var glowColor = 0xFFFF66;
      private var gradientGlow:GradientGlowFilter = new GradientGlowFilter();
      private var popContainer = new Sprite();
      private var totalScoreContainer = new Sprite();
      private var format:TextFormat = new TextFormat();
      private var tf_totalScore:TextField;
      private var killScoreArray = new Array();
      private var i:int;
      private var scoreCombo:uint;
      private var tf_popScore:TextField = new TextField();
      public var multiplier:int;

      public function Score(){
         multiplier =1; //default

         format.font = "Tahoma";
         format.color = 0x00CCFF;
         format.size = 14;
         format.bold = true;
         format.align = "right";
         format.leading=0;

         tf_totalScore= new TextField();
         tf_totalScore.autoSize = TextFieldAutoSize.RIGHT;
         tf_totalScore.selectable = false;
         tf_totalScore.defaultTextFormat = format;
         tf_totalScore.text = "0";
         tf_totalScore.antiAliasType = AntiAliasType.ADVANCED;

         tf_totalScore.x = 660;
         tf_totalScore.y = 23;

         this.addChild(popContainer);
         this.addChild(totalScoreContainer);
         totalScoreContainer.addChild(tf_totalScore);
         format.size = 12; //for the pop stuff
      }

      //getters
      public function gettotalScore():int{ return totalScore;} 
         
      public function resetScore():void{
         totalScore=0;
         tf_totalScore.text="0";
         cleanMemory();
         multiplier =1;
      }

      public function cleanMemory(){
         for(i=0; i < popContainer.numChildren; i++){
            popContainer.removeChildAt(i);
            killScoreArray[i] = null;
         }
         killScoreArray = new Array();
      }
      
      public function updateScoreNoPop(in_num){
         totalScore+= in_num;
         if(totalScore < 0)
            totalScore=0;
         tf_totalScore.text = totalScore+"";
      }
      
      //updates on top of enemy movie
      public function updateScore(in_num, in_x, in_y, in_size){
      format.size = in_size;
         if(in_num <0){
            format.color = 0xFF0000;
         }
         else{
            format.color = 0x00CCFF;
         }
         
         tf_popScore = new TextField();
         tf_totalScore.defaultTextFormat = format;

         tf_popScore.selectable = false;
         tf_popScore.defaultTextFormat = format;
         popContainer.addChild(tf_popScore);

         tf_popScore.text = (in_num) *multiplier+"";
         tf_popScore.x = in_x - 56;
         tf_popScore.y = in_y + 70;

         totalScore+= (in_num) *multiplier;
         if(totalScore < 0)
            totalScore=0;
         tf_totalScore.text = totalScore+"";
         numKills++;

         killScoreArray.push(tf_popScore);
         var tf_popScoreTimer:Timer = new Timer(30, 30);
         tf_popScoreTimer.addEventListener("timer", tf_popScoreTimerHandler);
         tf_popScoreTimer.start();
         

      }

      public function tf_popScoreTimerHandler(e){
         for(i =0;i < killScoreArray.length; i++){
            if(killScoreArray[i].alpha > 0){
              killScoreArray[i].y -= .3;
              killScoreArray[i].alpha -= .035;
            }
            else
            {
               killScoreArray[i].visible = false;
               killScoreArray[i].x = 1000;
               tf_popScore.x = 1000
               tf_popScore.visible = false;
               scoreCombo =0;
            }
         }
      }

   }//end class
}

