package code
{
   import code.*;
   import flash.display.MovieClip;
   import flash.events.*;
   import flash.display.*;
   import flash.utils.Timer;
   import flash.net.URLRequest;
   import flash.filters.BitmapFilterQuality;
   import flash.filters.BlurFilter;
   import flash.filters.BitmapFilterType;
   import flash.filters.GradientGlowFilter;
   import flash.text.*;
   import flash.media.Sound;
   import flash.media.SoundChannel;
   import flash.media.SoundTransform;
   import flash.geom.ColorTransform;

   public class Word extends MovieClip
   {
      private var moveTarget = true; //starts to move on create
      private var blur:BlurFilter = new BlurFilter();
      private var gradientGlow:GradientGlowFilter = new GradientGlowFilter();
      private var filterType:uint = 0;
      private var ID:uint;
      private var glowColor:uint;
      private var format:TextFormat = new TextFormat();
      private var selected:Boolean;
      private var rolledOver:Boolean;
      private var fadeTimer:Timer;
      private var maxSize:uint;
      private var wordType:Number;
      private var appearSound =  new sd_appear();
      private var appearChannel:SoundChannel; 
      private var boomAllSound =  new sd_boomAll();
      private var boomAllChannel:SoundChannel;  
      private var fadeSound =  new sd_fade();
      private var fadeChannel:SoundChannel;  
      private var fade2Sound =  new sd_fade2();
      private var fade2Channel:SoundChannel;  
      private var colorTransform = new ColorTransform();
      public var moveTimer:Timer;

      public var worth:int;
      public var word:String;
      public var wordTextField:TextField;
      public var originalWordLength:int;
      public var moveSpeed:Number;
      public var myFont:Font = new AvantGardEF();
      public var checkLoaded:Timer = new Timer(30, 0); //checks to see if the dictionary is loaded
    
      public function Word()
      {
         worth=1;
         blur.blurX = 10;
         blur.blurY = 10;
         blur.quality = BitmapFilterQuality.LOW;
         this.addEventListener(Event.REMOVED, removedDetected);
          
         wordTextField = new TextField();   
         
         format.font = "Tahoma";
         format.font = myFont.fontName;
         format.size = 16;
         wordTextField.antiAliasType = AntiAliasType.ADVANCED;
         wordTextField.selectable = false;
         wordTextField.defaultTextFormat = format;      
         addChild(wordTextField);
         wordTextField.autoSize = TextFieldAutoSize.RIGHT;

         this.x = 460;
         moveSpeed = Math.random();
         checkLoaded.addEventListener("timer", dictionaryLoadedHandler);
         checkLoaded.start();
      }

      public function dictionaryLoadedHandler(e:Event){
         if(Main.doneLoadingDictionary)
            loadWord();
      }
      
      private function loadWord(){
         checkLoaded.stop();
         var tempMov = MovieClip(Main.ldr.content);
         tempMov.setRandomWord();
         word = tempMov.wordStr;
         wordTextField.text = word;
         originalWordLength= word.length;
         wordType = Math.random();
         
         disableTyping();      
      }
      
      //getters
      public function getID():uint { return ID;}      
      public function getWord():String { return word;}
  //    public function getglowColor():uint { return glowColor;}
      public function getselected():Boolean{ return selected ;}
      public function getwordType():Number{ return wordType;}

      //settters
      public function setID(in_num) { ID=in_num;}    
      public function setselected(in_boo:Boolean){ selected = in_boo;}
      public function setwordType(in_num){ wordType = in_num;}
      
      public function updateWord(in_Str){
         word = in_Str;
         wordTextField.text = word;
      }

      public function startMovement(in_multiplier:Number){
         moveSpeed= moveSpeed*in_multiplier;
         moveTimer = new Timer(30, 0);
         moveTimer.addEventListener("timer", moveTimerHandler);
         moveTimer.start();         
      }
      
      public function moveTimerHandler(e:Event){
         this.x -= moveSpeed;
      
        // if(this.x < -1*wordTextField.textWidth)
        if(this.hitTestObject(Main.foreGround.m_wall))
            missed();
      }
      
      public function enableTyping(){
         colorTransform.color = 0xFF6600;
         this.transform.colorTransform = colorTransform;  
         wordTextField.alpha = 1;
         removeFilter()
      }
      
      public function disableTyping(){
         worth=1;
         colorTransform.color = 0xFFFFFF;
         this.transform.colorTransform = colorTransform; 
         wordTextField.alpha = .5;
          blurSelf();
      }
      
      public function disableTypingColor(in_color){
         colorTransform.color = in_color;
         this.transform.colorTransform = colorTransform; 
         wordTextField.alpha = .5;
          blurSelf();
      }  
      
      private function setglowColor(in_num){
         glowColor=in_num;
         glowSelf();
      }

      //function functions
      private function blurSelf(){
         this.filters = [blur];
         filterType = 1;
      }

      private function glowSelf(){
         this.filters = [gradientGlow];
         filterType = 2;
         selected = true;
      }
      
      private function removeFilter(){
         this.filters = null;
         filterType = 0;
      }  
      /*
      private function fadeHandler(e:Event){
         var tempNum:uint =randRange(1, 4);
         this.gotoAndPlay("out"+tempNum);
      }*/
      

      //this is called from when "out" is done playing
      public function missed(){       
         Main.wordMissedCounter++;
         Main.beforeBombHitCounter++;
    //     Main.score.updateScore(-5, this.x, this.y, 14);
         Main.updateDeathCounter(2*Main.score.multiplier);
         Main.loseLife();
         removeSelf();
      }
      
      public function removeSelf(){
         this.x=2000;
         this.visible = false;
      //   this.removeEventListener(MouseEvent.MOUSE_DOWN, mouseDown);
         this.removeEventListener(MouseEvent.MOUSE_OVER, mouseOver);
         moveTimer.stop();
      //   parent.removeChild(this);
      //  trace("removing self")
      }     
      
      public function removedDetected(e:Event){
   //   trace("remove detected")
         removeSelf();
      }
      
      public function gotHit(in_energy, in_getPoints){
         setselected(true);
         Main.updateDeathCounter(in_energy);
         Main.wordHitCounter++;
         Main.beforeBombHitCounter++;

         if(in_getPoints){
            Main.score.updateScore(int(maxSize-this.width/2), wordTextField.x, wordTextField.y, 14) ;
         }
         this.gotoAndPlay("selected");
//         removeSelf();
      }
      

      public function mouseOver(e:Event){  Main.selectWord(this);  }


   }//end class
}

